﻿using Infragistics.Documents.Excel;
using Infragistics.Documents.Excel.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sample212236
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Workbook workbook1 = new Workbook();
            Worksheet chartWorkSheet = workbook1.Worksheets.Add("Sheet 1");

            WorksheetCell cellChartBegin = chartWorkSheet.GetCell("A1");

            WorksheetChart  chart = chartWorkSheet.Shapes.AddChart(ChartType.Combo, cellChartBegin, new Point(0, 0), cellChartBegin, new Point(100, 100));//cellChartEnd?

            chart.SeriesOverlap = 100; //I need overlaped columns
            chart.GapWidth = 20;

            ChartType[] chartTypes = new ChartType[seriesCount];

            for (int i = 0; i < seriesCount; ++i)
            {
                chartTypes[i] = ChartType.ColumnStacked;
            }

            chart.SetComboChartSourceData(vRange.ToString(), chartTypes);
            //foreach (Series serie in chart.SeriesCollection)
            //{
            //    serie.Fill = new ChartSolidFill(new WorkbookColorInfo(document.BoxColor));
            //    serie.Border = new ChartBorder()
            //    {
            //        Fill = new ChartSolidFill(new WorkbookColorInfo(document.BorderColor))
            //    };
            //}

            //chart.ChartTitle = new ChartTitle()
            //{
            //    Text = new FormattedString(document.ChartTitle)
            //};

            chart.ChartArea.Border = new ChartBorder()
            {
                LineStyle = BorderLineStyle.Solid,
                WidthInPoints = 1
            };

            AxisCollection axis = chart.AxisCollection;
            Axis xAxis = axis[AxisType.Category, AxisGroup.Primary];

            xAxis.MajorTickMark = TickMark.None;
            xAxis.MinorTickMark = TickMark.None;

            xAxis.TickLabelPosition = TickLabelPosition.Low;
            //xAxis.AxisTitle = new ChartTitle()
            //{
            //    Text = new FormattedString(Resource.MainResources.BoxPlotChart_CategoryAxisTitle)
            //};

            xAxis.AxisBetweenCategories = true;

            xAxis.Position = AxisPosition.Bottom;

            Axis yAxis = axis[AxisType.Value, AxisGroup.Primary];

            SetAxisProperties(document.YAxis, yAxis);

            chart.SeriesCollection[0].Fill = new ChartEmptyFill();
            chart.SeriesCollection[0].Border = new ChartBorder() { Fill = new ChartEmptyFill() };
            chart.SeriesCollection[1].ErrorBars = new ErrorBars()
            {
                Direction = ErrorBarDirection.Minus,
                ErrorValueType = ErrorValueType.Percentage,
                Value = 100,
                EndStyle = EndStyleCap.Cap,
                WidthInPoints = 2
            };
            chart.SeriesCollection[1].Fill = new ChartEmptyFill();
            chart.SeriesCollection[1].Border = new ChartBorder() { Fill = new ChartEmptyFill() };
            chart.SeriesCollection[4].Fill = new ChartEmptyFill();
            chart.SeriesCollection[4].Border = new ChartBorder() { Fill = new ChartEmptyFill() };
            chart.SeriesCollection[4].ErrorBars = new ErrorBars()
            {
                Direction = ErrorBarDirection.Minus,
                ErrorValueType = ErrorValueType.Percentage,
                Value = 100,
                EndStyle = EndStyleCap.Cap,
                WidthInPoints = 2
            };

            //Add mean serie
            Series newSerie = chart.SeriesCollection.Add();

            newSerie.Name = new SeriesName("newSeries");// (Resource.MainResources.BoxPlotChart_LegendItem_Mean);

            WorksheetRegion xRange = GetWorksheetRegion(dataWorkSheet, startRow, startRow + GetTotalRequiredRows() - 1, 0, 0);
            WorksheetRegion yRange = GetWorksheetRegion(dataWorkSheet, startRow, startRow + GetTotalRequiredRows() - 1, 10, 10);

            newSerie.XValues = new XValues(dataWorkSheet, xRange.ToString());
            newSerie.Values = new SeriesValues(dataWorkSheet, yRange.ToString());
            newSerie.ChartType = ChartType.LineMarkers;
            newSerie.MarkerStyle = MarkerStyle.Square;
            newSerie.MarkerSize = 5;
            newSerie.MarkerFill = new ChartSolidFill(new WorkbookColorInfo(document.MeanMarkerColor));

            //newSerie.MarkerBorder = new ChartBorder()
            //{
            //    Fill = new ChartSolidFill(new WorkbookColorInfo(document.MeanMarkerColor))
            //};
            newSerie.Line = new ChartLine()
            {
                Fill = new ChartEmptyFill(),
                LineStyle = LineStyle.None,
                WidthInPoints = 0
            };

        }
    }

    public class ComboChart
    {
        public int Quantile25 { get; set; }
        public int LowQuantile { get; set; }
        public int Medial { get; set; }
        public int UpperQuantile { get; set; }
        public int Quantile97  { get; set; }
        public int Mean { get; set; }
    }
}
